//define class
class Order {

  constructor(squareMatrix) {

    if (squareMatrix) {
      this.matrix = squareMatrix;
      this.squareLen = this.matrix.length;
    }

  }

  _hasColumnZeroes(index) {

    for (var i = 0; i < this.matrix.length; ++i) {
      if (this.matrix[i][index] !== 0) {
        return false;
      }
    }

    return true;

  }

  _makeAllElementsInRowAsZero(index) {
    for (var i = 0; i < this.matrix.length; ++i) {
      this.matrix[index][i] = 0;
    }
  }


  _selfPointing() {
    let self = {};
    for (var i = 0; i < this.matrix.length; ++i) {
      if (this.matrix[i][i] === 1) {
        this.matrix[i][i] = 0;
        self[i] = i;
      }
    }
    return self;
  }

  _CycleBetweenNodes() {

    let two = [];

    for (var i = 0; i < this.matrix.length; ++i) {
      for (var j = i + 1; j < this.matrix.length; ++j) {
        if (i !== j && this.matrix[i][j] === 1 && this.matrix[j][i] === 1) {
          two.push([i, j]);
          console.log(i, j);
        }
      }
    }

    return two;

  }

  getOrder() {

    console.time('getOrder');

    let visited = {};
    let cycle = {};
    let order = [];
    let one = this._selfPointing();
    let two = this._CycleBetweenNodes();

    for (var i = 0; i < this.squareLen; ++i) {
      cycle[i] = i;
    }

    for (var i = 0; i < this.squareLen; ++i) {
      for (var j = 0; j < this.squareLen; ++j) {

        //console.log('- - - - - - - - - - - -- ');

        if (j in visited) {
          //console.log('Already visited',j);
        } else if (this._hasColumnZeroes(j)) {
          //console.log('Inserting to visit order --> ',j);
          visited[j] = j;
          delete cycle[j];
          order.push(j);
          this._makeAllElementsInRowAsZero(j);
        } else {
          //console.log('Column does not have zeroes',j);
        }

        if (order.length === this.squareLen) {
          console.timeEnd('getOrder');
          return {order, one, cycle};
        }
      }
    }

    console.timeEnd('getOrder');
    return {order, one, cycle, two};
  }

  setIndex(i, j) {
    if(i<this.matrix.length && j<this.matrix.length) {
      this.matrix[i][j] = 1;
    }

  }

  resetIndex(i, j) {
    if(i<this.matrix.length && j<this.matrix.length) {
      this.matrix[i][j] = 0;
    }
  }



}

//expose class
module.exports = Order;